/* -*- Mode: C -*-
 *Header:
 *File: recfile_change.C
 *Author: Noda Itsuki
 *Date: 1996/11/17
 *EndHeader:
 */

#include <stdio.h>
#include <unistd.h>
#include <iostream.h>
#include <netinet/in.h>

#include "param.h"
#include "types.h"
#include "old_types.h"

int main(int argc, char *argv[]) 
{
	void old_to_new(FILE *, FILE *) ;
	void new_to_old(FILE *, FILE *) ;
	FILE *src_fp ;
	FILE *dist_fp ;
	char src_file[MAX_FILE_LEN] ;
	char dist_file[MAX_FILE_LEN] ;
	int to_new ;

	if (argc == 3) {
		to_new = TRUE ;
		argv++ ;
	}
	else if (argc == 4 && !strcmp(argv[1], "-old")) {
		to_new = FALSE ;
		argv += 2 ;
	}
	else {
		cerr << "Usage: " << argv[0] << " [-old] src_file dist_file" << endl ;
		exit(-1) ;
	}

	strcpy(src_file, *argv++) ;
	strcpy(dist_file, *argv) ;

	if ((src_fp = fopen(src_file, "rb")) == NULL) {
		cerr << "can't open src_file: " << src_file << endl ;
		exit(-1) ;
	}
	if ((dist_fp = fopen(dist_file, "wb")) == NULL) {
		cerr << "can't open dist_file: " << dist_file << endl ;
		exit(-1) ;
	}

	if (to_new)
		old_to_new(src_fp, dist_fp) ;
	else
		new_to_old(src_fp, dist_fp) ;

	fclose(src_fp) ;
	fclose(dist_fp) ;

	exit(0) ;
}

void old_to_new(FILE *src_fp, FILE *dist_fp)
{
	dispinfo_t new_info ;
	old_dispinfo_t old_info ;
	int i ;

	while(fread((char *)(&old_info), sizeof(old_info), 1, src_fp) != 0) {
		new_info.mode = htons(old_info.mode) ;
		switch (old_info.mode) {
		case SHOW_MODE:
			new_info.body.show.pmode = old_info.body.show.pmode ;
			strcpy(new_info.body.show.team[0].name,
						old_info.body.show.team[0].name) ;
			new_info.body.show.team[0].score
						= htons(old_info.body.show.team[0].score) ;
			strcpy(new_info.body.show.team[1].name,
						old_info.body.show.team[1].name) ;
			new_info.body.show.team[1].score
						= htons(old_info.body.show.team[1].score) ;
			for(i=0; i <= MAX_PLAYER * 2 ; i++) {
				new_info.body.show.pos[i].enable
							= htons(old_info.body.show.pos[i].enable) ;
				new_info.body.show.pos[i].side
							= htons(old_info.body.show.pos[i].side) ;
				new_info.body.show.pos[i].unum
							= htons(old_info.body.show.pos[i].unum) ;
				new_info.body.show.pos[i].angle
							= htons(old_info.body.show.pos[i].angle) ;
				new_info.body.show.pos[i].x = htons(old_info.body.show.pos[i].x) ;
				new_info.body.show.pos[i].y = htons(old_info.body.show.pos[i].y) ;
			}
			new_info.body.show.time = htons(old_info.body.show.time) ;
			break ;

		case MSG_MODE:
			new_info.body.msg.board = htons(old_info.body.msg.board) ;
			strcpy(new_info.body.msg.message, old_info.body.msg.message) ;
			break ;

		default:
			break ;
		}
	fwrite((char *)&new_info, sizeof(new_info), 1, dist_fp) ;
	}
}

void new_to_old(FILE *src_fp, FILE *dist_fp)
{
	dispinfo_t new_info ;
	old_dispinfo_t old_info ;
	int i ;

	while(fread((char *)(&new_info), sizeof(new_info), 1, src_fp) != 0) {
		old_info.mode = (char)ntohs(new_info.mode) ;
		switch (old_info.mode) {
		case SHOW_MODE:
			old_info.body.show.gwidth = (short)GOAL_WIDTH ;
			old_info.body.show.pmode = new_info.body.show.pmode ;
			strcpy(old_info.body.show.team[0].name,
						new_info.body.show.team[0].name) ;
			old_info.body.show.team[0].score
						= (char)ntohs(new_info.body.show.team[0].score) ;
			strcpy(old_info.body.show.team[1].name,
						new_info.body.show.team[1].name) ;
			old_info.body.show.team[1].score
						= (char)ntohs(new_info.body.show.team[1].score) ;
			for(i=0; i <= MAX_PLAYER * 2 ; i++) {
				old_info.body.show.pos[i].enable
							= (char)ntohs(new_info.body.show.pos[i].enable) ;
				old_info.body.show.pos[i].side
							= (char)ntohs(new_info.body.show.pos[i].side) ;
				old_info.body.show.pos[i].unum
							= (char)ntohs(new_info.body.show.pos[i].unum) ;
				old_info.body.show.pos[i].angle
							= ntohs(new_info.body.show.pos[i].angle) ;
				old_info.body.show.pos[i].x = ntohs(new_info.body.show.pos[i].x) ;
				old_info.body.show.pos[i].y = ntohs(new_info.body.show.pos[i].y) ;
			}
			old_info.body.show.time = (int)ntohs(new_info.body.show.time) ;
			break ;

		case MSG_MODE:
			old_info.body.msg.board = (char)ntohs(new_info.body.msg.board) ;
			strcpy(old_info.body.msg.message, new_info.body.msg.message) ;
			break ;

		default:
			break ;
		}
	fwrite((char *)&old_info, sizeof(old_info), 1, dist_fp) ;
	}
}
